\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


read("c-curve-defines.gp");

check_count = 0;
check_exact(got,want, name="") =
{
  check_count++;
  if(got!= want,
     print("\nwrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------


vector(12,k,k--; GpartTotal_by_segments(k))


real_w8_pow(n) = vector_modulo([1,   1/2*sqrt2, 0, -1/2*sqrt2, \
                                -1, -1/2*sqrt2, 0,  1/2*sqrt2 ],n);
\\ vector(8,n,n--; real_w8_pow(n))
\\ vector(8,n,n--; real_w8_pow(n-2))
\\ vector(8,n,n--; real_w8_pow(n) * vector_modulo([)

greal_w8_pow(x) = Polrev([1,   1/2*sqrt2, 0, -1/2*sqrt2, \
                          -1, -1/2*sqrt2, 0,  1/2*sqrt2 ])/(1-x^8);
check_exact(vector(16,k,k--; real_w8_pow(k)), gf_terms(greal_w8_pow(x), 16));

greal_w8_pow_ksub2(x) = Polrev([0,  1/2*sqrt2 , 1,   1/2*sqrt2, 0, -1/2*sqrt2, \
                                -1, -1/2*sqrt2])/(1-x^8);
check_exact(vector(16,k,k--; real_w8_pow(k-2)), gf_terms(greal_w8_pow_ksub2(x), 16));

\\ GpartTotal(k) + 2*sum(j=0,k-1, GpartTotal(j)*real_w8_pow(k-j)) == GN(k)
\\ 2*sum(j=0,k-1, GpartTotal(j)*real_w8_pow(k-j)) == GN(k) - GpartTotal(k)
\\
\\ GpartTotal(k) + 2*GpartTotal(k-1)*real_w8_pow(1)
\\           + 2*GpartTotal(k-2)*real_w8_pow(2)
\\           + 2*GpartTotal(k-3)*real_w8_pow(3)
\\           + 2*GpartTotal(k-4)*real_w8_pow(4)
\\           - 2*sum(j=0,k-5, GpartTotal(j)*real_w8_pow(k-j)) == GN(k)
\\
\\ GpartTotal(k) + 2*GpartTotal(k-1)*sqrt2
\\           + 2*GpartTotal(k-2)*0
\\           + 2*GpartTotal(k-3)*-sqrt2
\\           + 2*GpartTotal(k-4)*-1
\\           - (GN(k-4) - GpartTotal(k-4)) == GN(k)

\\    *---*---*---*---*          Y=3      4*3 + 2*(2+1/2) == 17
\\           ||       |
\\            *       *---*
\\                        |
\\                    +   *
\\                        |
\\            +       *---*
\\ 30-9-4
\\ (1/2*sqrt2^3 * PartSegments(3) + GpartTotal_by_segments(3) ) * 1/2*sqrt2 * 2
\\ (1/2*sqrt2^2 * PartSegments(2)                         )             * 2


\\     *   *
\\      \ / \
\\       *   *
\\            \
\\             *
\\           // \
\\           *   *
\\                \
\\                 *       (2+1/2)*1/2*sqrt2 = 5/4*sqrt2
\\                /
\\               *
\\                \
\\                 *
\\                /
\\           *   *
\\            \ /
\\             *
\\ GN(5)                 == 62*sqrt2
\\ GpartTotal_by_segments(5) == (29+1/2)*sqrt2
\\ (1/2*sqrt2^4 * PartSegments(4) + GpartTotal_by_segments(4) ) * 1/2*sqrt2 * 2 == 29*sqrt2
\\ (1/2*sqrt2^3 * PartSegments(3)                         )             * 2 == 4*sqrt2
\\ (1/2*sqrt2^2 * PartSegments(2) + GpartTotal_by_segments(2) ) * 1/2*sqrt2 * 2 == 4*sqrt2
\\ GN(1)                 == 1/2*sqrt2

GpartTotal(k) =
{
  if(k==0,0, k==1,0, k==2,2, k==3,5/2*sqrt2,
     GN(k)
     - 2*( GpartTotal(k-1) + PartSegments(k-1)* 1/2*sqrt2^(k-1) ) * 1/2*sqrt2
     - 2*(               PartSegments(k-2)* 1/2*sqrt2^(k-2) )
     + 2*( GpartTotal(k-3) + PartSegments(k-3)* 1/2*sqrt2^(k-3) ) * 1/2*sqrt2
     + GpartTotal(k-4)
     + GN(k-4)
    );
}
\\ GpartTotal = memoize(GpartTotal);
vector(12,k,k--; GpartTotal(k))

GpartTotal(k) =
{
  if(k==0,0, k==1,0, k==2,2, k==3,5/2*sqrt2,
     GN(k)
     - 2*( PartSegments(k-1)* 1/2*sqrt2^(k-2) + GpartTotal(k-1) * 1/2*sqrt2 )
     - 2*( PartSegments(k-2)* 1/2*sqrt2^(k-2)             )
     + 2*( PartSegments(k-3)* 1/2*sqrt2^(k-4) + GpartTotal(k-3) * 1/2*sqrt2 )
     + GpartTotal(k-4)
     + GN(k-4)
    );
}
\\ GpartTotal = memoize(GpartTotal);
vector(12,k,k--; GpartTotal(k))


{
  check_exact(vector(16,k,k--; vector_modulo([1, -sqrt2, 1, 0, -1, sqrt2, -1, 0],k)),
              gf_terms(1/(1 + sqrt2*x + x^2), 16));
}
{
  check_exact(vector(16,k,k--;
                     vector_modulo([-20/13, 12/13*sqrt2, -4/13, -8/13*sqrt2, 20/13, -12/13*sqrt2, 4/13, 8/13*sqrt2],k)),
              gf_terms((-20/13 - 8/13*sqrt2*x)/(1 + sqrt2*x + x^2), 16));
}

GpartTotal(k) =
{
  151/546* vector_modulo([1, 1, 1, 1],k) * (2*sqrt2)^k
  + vector_modulo(-2/3* [1, -1, 1, -1] -1/2* [1, 1, 1, 1],k) * (sqrt2)^k
  + vector_modulo((17/14 + 23/28*sqrt2)* [1, -1, 1, -1] + (17/14 - 23/28*sqrt2)* [1, 1, 1, 1],k)
  + vector_modulo([-20/13, 12/13*sqrt2, -4/13, -8/13*sqrt2, 20/13, -12/13*sqrt2, 4/13, 8/13*sqrt2],k)
  ;
  \\ if(k==0,0, k==1,0, k==2,2, k==3,5/2*sqrt2,
  \\    GN(k)
  \\    - ( GpartTotal(k-1) + PartSegments(k-1)* 1/2*sqrt2^(k-1) ) * 1/2*sqrt2
  \\    - ( GN(k-1)     + 2^(k-1)          * 1/2*sqrt2^(k-1) ) * 1/2*sqrt2
  \\   );
}
vector(10,k,k--; GpartTotal(k))
\\quit();

\\ wrong
\\ GpartTotal(k) =
\\ {
\\   if(k==0,0, k==1,0, k==2,2, k==3,5/2*sqrt2,
\\      GN(k)
\\      - ( GpartTotal(k-1) + PartSegments(k-1)* 1/2*sqrt2^(k-1) ) * 1/2*sqrt2
\\      - ( GN(k-1)     + 2^(k-1)          * 1/2*sqrt2^(k-1) ) * 1/2*sqrt2
\\     );
\\ }
\\ vector(10,k,k--; GpartTotal(k))

\\ 1, sqrt2, 0, -sqrt2, -1,
\\ 0, sqrt2, 1, sqrt2, 0,
GN_by_parts(k) =
{
  GpartTotal_by_segments(k)
  + 2*sum(j=0,k-1,
            GpartTotal_by_segments(j)          * real_w8_pow(k-j)
            + PartSegments(j)* 1/2*sqrt2^j * real_w8_pow(k-j-2));
}
print("GN");
vector(14,k,k--; GN(k))
vector(14,k,k--; GN_by_parts(k))

GN_by_parts(k) =
{
  GpartTotal_by_segments(k)
  + 2*sum(j=0,k-1,
            GpartTotal_by_segments(j)          * real(b^(k-j))/sqrt2^(k-j)
            + PartSegments(j)* 1/2*sqrt2^j * real(b^(k-j-2))/sqrt2^(k-j-2));
}
vector(14,k,k--; GN_by_parts(k))

\\ w8 = b/sqrt(2);
\\ GN_by_parts(k) =
\\ {
\\   GpartTotal_by_segments(k)
\\   + 2*sum(j=0,k-1,
\\             GpartTotal_by_segments(j)                      * real(w8^(k-j))
\\             + PartSegments(j)* 1/2*sqrt2^j * real(w8^(k-j-2)));
\\ }
\\ vector(14,k,k--; GN_by_parts(k))

\\ GN_by_parts(k) =
\\ {
\\   real(GpartTotal_by_segments(k)
\\        + 2*sum(j=0,k-1,
\\                  GpartTotal_by_segments(j)                      * w8^(k-j)
\\                  + PartSegments(j) * 1/2*sqrt2^j * w8^(k-j-2)));
\\ }
\\ vector(14,k,k--; GN_by_parts(k))


GN_sub_GN8_by_parts(k) =
{
  GpartTotal_by_segments(k)
  - GpartTotal_by_segments(k-8)
  + 2*sum(j=k-8,k-1,
            GpartTotal_by_segments(j)          * real(b^(k-j))/sqrt2^(k-j)
            + PartSegments(j)* 1/2*sqrt2^j * real(b^(k-j-2))/sqrt2^(k-j-2))
  ;
}
print("GN(k) sub GN(k-8)");
vector(6,k,k--;k+=8; GN(k)-GN(k-8))
vector(6,k,k--;k+=8; GN_sub_GN8_by_parts(k))

GN_sub_GN8_by_parts(k) =
{
  GpartTotal_by_segments(k)
  - GpartTotal_by_segments(k-8)
  + 2*sum(j=k-8,k-1,
            GpartTotal_by_segments(j)          * real_w8_pow(k-j)    /* 8 to 1 */
            + PartSegments(j)* 1/2*sqrt2^j * real_w8_pow(k-j-2))
  ;
}
vector(6,k,k--;k+=8; GN_sub_GN8_by_parts(k))

GpartTotal(k) =
{
  if(k<8, return(GpartTotal_by_segments(k)));
  GN(k)
  - GN(k-8)
  + GpartTotal(k-8)
  - 2*sum(j=k-8,k-1,
            GpartTotal(j)                      * real_w8_pow(k-j)
            + PartSegments(j)* 1/2*sqrt2^j * real_w8_pow(k-j-2))
  ;
}
GpartTotal = memoize(GpartTotal);
vector(6,k,k--;k+=8; GpartTotal_by_segments(k))
vector(6,k,k--;k+=8; GpartTotal(k))

GpartTotal(k) =
{
  if(k<4, return(GpartTotal_by_segments(k)));
  GN(k)
  + GN(k-4)
  - GpartTotal(k-4)
  - 2*sum(j=k-4,k-1,
            GpartTotal(j)                      * real_w8_pow(k-j)
            + PartSegments(j)* 1/2*sqrt2^j * real_w8_pow(k-j-2))
  ;
}
GpartTotal = memoize(GpartTotal);
vector(6,k,k--;k+=8; GpartTotal(k))

GpartTotal(k) =
{
  if(k<4, return(GpartTotal_by_segments(k)));
  GN(k)
  + GN(k-4)
  - GpartTotal(k-4)
  - 2*( GpartTotal(k-4)                          * real_w8_pow(k-(k-4))
        + PartSegments(k-4)* 1/2*sqrt2^(k-4) * real_w8_pow(k-(k-4)-2) )
  - 2*( GpartTotal(k-3)                          * real_w8_pow(k-(k-3))
        + PartSegments(k-3)* 1/2*sqrt2^(k-3) * real_w8_pow(k-(k-3)-2) )
  - 2*( GpartTotal(k-2)                          * real_w8_pow(k-(k-2))
        + PartSegments(k-2)* 1/2*sqrt2^(k-2) * real_w8_pow(k-(k-2)-2) )
  - 2*( GpartTotal(k-1)                          * real_w8_pow(k-(k-1))
        + PartSegments(k-1)* 1/2*sqrt2^(k-1) * real_w8_pow(k-(k-1)-2) )
  ;
}
GpartTotal = memoize(GpartTotal);
vector(6,k,k--;k+=8; GpartTotal(k))

GpartTotal(k) =
{
  if(k<4, return(GpartTotal_by_segments(k)));
  GN(k)
  - 2*( PartSegments(k-1)* 1/2*sqrt2^(k-2)
        + GpartTotal(k-1)                          * 1/2*sqrt2
      )
  - 2*( PartSegments(k-2)* 1/2*sqrt2^(k-2)
      )
  - 2*( PartSegments(k-3)* 1/2*sqrt2^(k-4)
        + GpartTotal(k-3)                          * -1/2*sqrt2
      )
  + GN(k-4)
  + GpartTotal(k-4)  
  ;
}
GpartTotal = memoize(GpartTotal);
vector(6,k,k--;k+=8; GpartTotal(k))
quit



\\ vector(100,k,k--; GpartTotal(k))

GpartTotal_formula(k) =
{
  11/42 * (2*sqrt2)^k
  + 1/6 * vector_modulo([1, -7],k) * (sqrt2)^k
  + 3/14*vector_modulo([-2, 3*sqrt2],k)
}
vector(16,k,k--; GpartTotal(k))
vector(16,k,k--; GpartTotal_formula(k))

\\ PartSegments(k) = 1/3*(2^k + vector_modulo([2,-2],k));
\\ 11/42 / (1/3) == 11/14

quit();

\\
\\ GpartTotal(k) + 2*GpartTotal(k-1)*sqrt2
\\           - 2*GpartTotal(k-3)*sqrt2
\\           - 2*GpartTotal(k-4)
\\           - GN(k-4) + GpartTotal(k-4)  == GN(k)
\\
\\ GpartTotal(k) + 2*GpartTotal(k-1)*sqrt2
\\           - 2*GpartTotal(k-3)*sqrt2
\\           - 1*GpartTotal(k-4)
\\           - GN(k-4)           == GN(k)
\\
\\ gGpartTotal(x) + 2*sqrt2*1/x   * gGpartTotal(x)
\\            - 2*sqrt2*1/x^2 * gGpartTotal(x)
\\            -         1/x^4 * gGpartTotal(x)
\\            -         1/x^4 * ( - x^3 - x^4)
\\            - gGN(x)*1/x^4     == gGN(x)

\\ (1 + 2*sqrt2*1/x - 2*sqrt2*1/x^2 - 1/x^4) * gGpartTotal(x)
\\    == (1 + 1/x^4) *gGN(x) + 1/x^4 * ( - x^3 - x^4)

check_exact(Rpart(0), 1);
check_exact(Rpart(1), 0);
check_exact(Rpart(2), 2);
check_exact(Rpart(3), 2, "Rpart(3)");
\\
\\ k=0  0  segment  *---*
\\ k=1  0  empty
\\ k=2  1  *---*---*
\\ k=3  1  *   *           (2+1/2)*1/2*sqrt2 = 5/4*sqrt2
\\          \ / \
\\           *   *
\\                \
\\                 *
\\                /
\\               *
gGpartTotal(x) =
{
  (
   (1 + 1/x^4) *gGN(x)
   + 1/x^4 * ( - x^3 - x^4)
  )
  / (1 + 2*sqrt2*1/x - 2*sqrt2*1/x^2 - 1/x^4)
  ;
}

gf_terms(gGpartTotal(x),10)
