\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


read("c-curve-defines.gp");

check_count = 0;
check_exact(got,want, name="") =
{
  check_count++;
  if(got!= want,
     print("\nwrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count));
}

\\-----------------------------------------------------------------------------

print("bottom");
bottom(k) = if(k<=4,1, k<=6,3, 2*bottom(k-2)+2);
forstep(k=4,12,2, print1(bottom(k),", ")); print();
bottom(k) = if(k<=4,1, 5*2^floor((k-5)/2) - 2);
forstep(k=4,12,2, print1(bottom(k),", ")); print();

print("vertical");
vertical(k) = bottom(k) - if(k==4,0, Rpart(k-5)/2);
forstep(k=4,12,2, print1(Rpart(k-5)/2,", ")); print();
forstep(k=4,12,2, print1(vertical(k),", ")); print();
vertical(k) = 2*2^((k-4)/2) - 1;
forstep(k=4,12,2, print1(vertical(k),", ")); print();

print("outward");
outward(k) = 1/2*Rpart(k-4) + Rpart(k-5)/2;
forstep(k=4,12,2, print1(outward(k),", ")); print();
outward(k) = 2^floor((k-4)/2) - 1;
forstep(k=4,12,2, print1(outward(k),", ")); print();

print("horizontal");
horizontal(k) = 1/2*Rpart(k) - outward(k);
forstep(k=4,16,2, print1(horizontal(k),", ")); print();
horizontal(k) = 2^((k-4)/2) + 1;
forstep(k=4,16,2, print1(horizontal(k),", ")); print();

slope(k) = vertical(k) / horizontal(k);
forstep(k=4,12,2, printf("k=%d, %d %d %.6f\n", k, horizontal(k), vertical(k), slope(k)));
my(k=1000); printf("%.6f\n", slope(k));

