#!/usr/bin/perl -w

# Copyright 2014, 2015, 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use FindBin;
use List::Util 'min','max';

use FindBin;
BEGIN { unshift @INC, $FindBin::Bin }
use MyCCurve 'xyxy_convex_hull_overlap','xy_rotate_minus90','chamfer';
use MyPrintwrap ':all';


print "  % generated by tools/$FindBin::Script\n";

$Printwrap = 2;

my $href = xyxy_convex_hull_overlap();
my $count = 0;
foreach my $key (keys %$href) {
  next if $key eq '0,0, -1,0';

  my ($x1,$y1, $x2,$y2) = split /,\s*/, $key;

  if (xyxy_convex_hull_overlap()->{"$x2,$y2, $x1,$y1"}) {
    my $dx = $x2 - $x1;
    my $dy = $y2 - $y1;
    ($dx,$dy) = xy_rotate_minus90($dx,$dy);
    $x1 = $x1 . chamfer($dx,'\MyOverlapGap');
    $y1 = $y1 . chamfer($dy,'\MyOverlapGap');
    $x2 = $x2 . chamfer($dx,'\MyOverlapGap');
    $y2 = $y2 . chamfer($dy,'\MyOverlapGap');
    printwrap(" \\draw[-{>[harpoon,swap]}] ($x1,$y1)--($x2,$y2);");
  } else {
    printwrap(" \\draw[->] ($x1,$y1)--($x2,$y2);");
  }
  $count++;
}
printwrap_newline();

print "  % count $count, excluding middle itself\n";
print "  % end generated\n";
exit 0;
